﻿--[[
	Advancement
	Based on sExperienceBar, which was based on eXPeritia_basic
	Version: 1
	Author: Vlakarados
]]--


local addon, ns = ...

local fc = ns.fc -- Get functions
local tbl = ns.tbl -- Get tables

local addonversion = "1, public"

local mcfg
local defaults = {
	['Width'] = 500,
	['Height'] = 14,
}

local m, msg
local classColor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
local _G = getfenv(0)

local xpbar = CreateFrame("Frame", "AdvancementBar", UIParent)
xpbar:SetPoint("TOP", UIParent, "TOP", 0, -19) -- Adjusted here to move the bar
xpbar:SetWidth(defaults.Width)
xpbar:SetHeight(defaults.Height)

xpbar:SetClampedToScreen(true)
xpbar:SetMovable(1)
xpbar:SetUserPlaced(true)

xpbar:EnableMouse(true)
xpbar:RegisterForDrag("")
xpbar.Draggable=false
xpbar:SetScript("OnDragStart", function(s)
  xpbar:StartMoving()
end)
xpbar:SetScript("OnDragStop", function(s)
  xpbar:StopMovingOrSizing()
end)




local font = CreateFont("xpBarFont")
font:SetFontObject(GameFontHighlightSmall)
font:SetTextColor(classColor.r, classColor.g, classColor.b)
font:SetFont("Fonts\ARIALN.ttf", 8, "OUTLINE")



local textMain = xpbar:CreateFontString(nil, "OVERLAY")
textMain:SetPoint("LEFT", indicator, "RIGHT", 10, 0)
textMain:SetFontObject(font)

local textTR = xpbar:CreateFontString(nil, "OVERLAY")
textTR:SetPoint("BOTTOMRIGHT", xpbar, "TOPRIGHT", 0, 2)
textTR:SetFontObject(font)

local textTL = xpbar:CreateFontString(nil, "OVERLAY")
textTL:SetPoint("BOTTOMLEFT", xpbar, "TOPLEFT", 0, 2)
textTL:SetFontObject(font)

local textBR = xpbar:CreateFontString(nil, "OVERLAY")
textBR:SetPoint("TOPRIGHT", xpbar, "BOTTOMRIGHT", 0, -2)
textBR:SetFontObject(font)

local textBL = xpbar:CreateFontString(nil, "OVERLAY")
textBL:SetPoint("TOPLEFT", xpbar, "BOTTOMLEFT", 0, -2)
textBL:SetFontObject(font)

local textQxp = xpbar:CreateFontString(nil, "OVERLAY")
textQxp:SetPoint("LEFT", textBL, "RIGHT", 7, 0)
textQxp:SetFontObject(font)
textQxp:SetText("")
xpbar.addtext = true

local temr,temg,temb,tempa

local thisisit = true
local menuFrame = CreateFrame("Frame", "ExampleMenuFrame", UIParent, "UIDropDownMenuTemplate")
local function mouseclick(self, button)

	collectgarbage("collect")

	local menu = {
		{ text = "Advancement", isTitle = true, notCheckable = true},
		{ text = "", notCheckable = true, disabled = true},

		--------------------------------

		{ text = "Config", isTitle = true, notCheckable = true},
		{ text = "Show", hasArrow = true, notCheckable = true, menuList = {
			{ text = "Rested and QXP", tooltipTitle = "Rested and QXP", tooltipText = "Show or hide rested and completed quest reward experience text", notCheckable = false, checked = xpbar.addtext, func = function()
				if(xpbar.addtext) then
					textQxp:Hide()
					xpbar.addtext = false
					mcfg.show.tqxp = false
				else
					textQxp:Show()
					xpbar.addtext = true
					mcfg.show.tqxp = true
				end
			end },
			}
		},
		{ text = "Size", hasArrow = true, notCheckable = true, menuList = {
				{ text = "Bar width", notCheckable = true, func = function()
					StaticPopupDialogs["setwidth"] = {
						text = "Please type the width of the bar",
						button1 = ACCEPT,
						button2 = CANCEL,
						hasEditBox = 1,
						timeout = 30,
						hideOnEscape = 1,
						OnAccept = 	function(self)
							local text = self.editBox:GetText()
							if (tonumber(text)) then
								mcfg.size.width = tonumber(string.format("%.0f", text))
								xpbar:SetWidth(mcfg.size.width)
								defaults.Height = mcfg.size.height and mcfg.size.height or defaults.Height
								defaults.Width = mcfg.size.width and mcfg.size.width or defaults.Width

								xpbar:PLAYER_ENTERING_WORLD()
							else
								print("This is not a number, please enter a valid integer")
							end
						end,
					}
					StaticPopup_Show("setwidth")
				end },
				{ text = "Bar height", notCheckable = true, func = function()
					StaticPopupDialogs["setheight"] = {
						text = "Please type the height of the bar",
						button1 = ACCEPT,
						button2 = CANCEL,
						hasEditBox = 1,
						timeout = 30,
						hideOnEscape = 1,
						OnAccept = 	function(self)
							local text = self.editBox:GetText()
							if (tonumber(text)) then
								mcfg.size.height = tonumber(string.format("%.0f", text))
								xpbar:SetHeight(mcfg.size.height)
								defaults.Height = mcfg.size.height and mcfg.size.height or defaults.Height
								defaults.Width = mcfg.size.width and mcfg.size.width or defaults.Width
								xpbar.ind:SetHeight(defaults.Height+4)
								xpbar.rind:SetHeight(defaults.Height+4)
								xpbar.qxpind:SetHeight(defaults.Height+4)


								xpbar:PLAYER_ENTERING_WORLD()

							else
								print("This is not a number, please enter a valid integer")
							end
						end,
					}
					StaticPopup_Show("setheight")
				end },
				{ text = "Indicators width (!)", tooltipTitle = "Indicators width", tooltipText = "Play with this value as it depends on your UI Scale, try setting to something like 1.3 or 2.4 if you don't see or see one of the indicators transparent", notCheckable = true, func = function()
					StaticPopupDialogs["setheight"] = {
						text = "Please type the width of indicators",
						button1 = ACCEPT,
						button2 = CANCEL,
						hasEditBox = 1,
						timeout = 30,
						hideOnEscape = 1,
						OnAccept = 	function(self)
							local text = self.editBox:GetText()
							if (tonumber(text)) then
								mcfg.size.iw = tonumber(string.format("%.3f", text))

								xpbar.ind:SetWidth(mcfg.size.iw)
								xpbar.rind:SetWidth(mcfg.size.iw)
								xpbar.qxpind:SetWidth(mcfg.size.iw)


								xpbar:PLAYER_ENTERING_WORLD()

							else
								print("This is not a number, please enter a valid real number")
							end
						end,
					}
					StaticPopup_Show("setheight")
				end },
				}
			},
		{ text = "Colors", hasArrow = true, notCheckable = true, menuList = {
			{ text = "Bar color", hasArrow = true, notCheckable = true, menuList = {
					{ text = "Set color", notCheckable = true, hasColorSwatch = true,
					r = select(1, xpbar.bg:GetVertexColor()), g = select(2, xpbar.bg:GetVertexColor()), b = select(3, xpbar.bg:GetVertexColor()),
					swatchFunc = function()
							xpbar.bg:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)
							mcfg.c.bg.r = select(1,ColorPickerFrame:GetColorRGB())
							mcfg.c.bg.g = select(2,ColorPickerFrame:GetColorRGB())
							mcfg.c.bg.b = select(3,ColorPickerFrame:GetColorRGB())
					end,
					},
					{ text = "Class color", notCheckable = true, func = function()
							xpbar.bg:SetVertexColor(classColor.r, classColor.g, classColor.b, 1)
							mcfg.c.bg.r = classColor.r
							mcfg.c.bg.g = classColor.g
							mcfg.c.bg.b = classColor.b

					end },
				}
			},

			{ text = "Exp/Rep indicator color", hasArrow = true, notCheckable = true, menuList = {
					{ text = "Set color", notCheckable = true, hasColorSwatch = true,
					r = select(1, xpbar.ind:GetVertexColor()), g = select(2, xpbar.ind:GetVertexColor()), b = select(3, xpbar.ind:GetVertexColor()),
					swatchFunc = function()
							xpbar.ind:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)
							mcfg.c.ind.r = select(1,ColorPickerFrame:GetColorRGB())
							mcfg.c.ind.g = select(2,ColorPickerFrame:GetColorRGB())
							mcfg.c.ind.b = select(3,ColorPickerFrame:GetColorRGB())
					end,
					},
					{ text = "Class color", notCheckable = true, func = function()
						xpbar.ind:SetVertexColor(classColor.r, classColor.g, classColor.b, 1)
							mcfg.c.ind.r = classColor.r
							mcfg.c.ind.g = classColor.g
							mcfg.c.ind.b = classColor.b

					end },
				}
			},
			{ text = "Rested indicator color", hasArrow = true, notCheckable = true, menuList = {
					{ text = "Set color", notCheckable = true, hasColorSwatch = true,
					r = select(1, xpbar.rind:GetVertexColor()), g = select(2, xpbar.rind:GetVertexColor()), b = select(3, xpbar.rind:GetVertexColor()),
					swatchFunc = function()
							xpbar.rind:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)
							mcfg.c.rind.r = select(1,ColorPickerFrame:GetColorRGB())
							mcfg.c.rind.g = select(2,ColorPickerFrame:GetColorRGB())
							mcfg.c.rind.b = select(3,ColorPickerFrame:GetColorRGB())
					end,
					},
					{ text = "Class color", notCheckable = true, func = function()
							xpbar.rind:SetVertexColor(classColor.r, classColor.g, classColor.b, 1)
							mcfg.c.rind.r = classColor.r
							mcfg.c.rind.g = classColor.g
							mcfg.c.rind.b = classColor.b
					end },
				}
			},
			{ text = "Qxp indicator color", hasArrow = true, notCheckable = true, menuList = {
					{ text = "Set color", notCheckable = true, hasColorSwatch = true,
					r = select(1, xpbar.qxpind:GetVertexColor()), g = select(2, xpbar.qxpind:GetVertexColor()), b = select(3, xpbar.qxpind:GetVertexColor()),
					swatchFunc = function()
							xpbar.qxpind:SetVertexColor(select(1,ColorPickerFrame:GetColorRGB()), select(2,ColorPickerFrame:GetColorRGB()), select(3,ColorPickerFrame:GetColorRGB()) , 1)
							mcfg.c.qxpind.r = select(1,ColorPickerFrame:GetColorRGB())
							mcfg.c.qxpind.g = select(2,ColorPickerFrame:GetColorRGB())
							mcfg.c.qxpind.b = select(3,ColorPickerFrame:GetColorRGB())
					end,
					},
					{ text = "Class color", notCheckable = true, func = function()
							xpbar.qxpind:SetVertexColor(classColor.r, classColor.g, classColor.b, 1)
							mcfg.c.qxpind.r = classColor.r
							mcfg.c.qxpind.g = classColor.g
							mcfg.c.qxpind.b = classColor.b
					end },
				}
			},
		}
	},

		{ text = "Draggable", tooltipTitle = "Draggable", tooltipText = "Lock / Unlock the bar to allow moving by dragging the bar with Left Mouse Button", notCheckable = false, checked = xpbar.Draggable, func = function()

			if(xpbar.Draggable) then
				xpbar:RegisterForDrag("")
				xpbar.Draggable = false
			else
				xpbar:RegisterForDrag("LeftButton")
				xpbar.Draggable = true
			end
		end },
		{ text = "", notCheckable = true, disabled = true},
		{ text = "Get quest reward exp", tooltipTitle = "Print completed quest reward exp", tooltipText = "Print to the chat frame(not public) the completed quest links, experience they award and totals", notCheckable = true, func = function()
			fc.GetQxp(nil, 1)
		end },
	}
	if button == "RightButton" then
		EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU");
	end
end


--[[
	Helper Functions
--]]

function xpbar:ADDON_LOADED(event, arg1)
	if arg1 == "Advancement" then

			AdvancementT = AdvancementT or {}
			mcfg = AdvancementT

			mcfg.c = mcfg.c or {}
			mcfg.c.bg = mcfg.c.bg or {}
			mcfg.c.ind = mcfg.c.ind or {}
			mcfg.c.rind = mcfg.c.rind or {}
			mcfg.c.qxpind = mcfg.c.qxpind or {}

			mcfg.size = mcfg.size or {}
			mcfg.show = mcfg.show or {}

			-- Let's go
			xpbar:SetWidth(mcfg.size.width and mcfg.size.width or defaults.Width)
			xpbar:SetHeight(mcfg.size.height and mcfg.size.height or defaults.Height)
			defaults.Height = mcfg.size.height and mcfg.size.height or defaults.Height
			defaults.Width = mcfg.size.width and mcfg.size.width or defaults.Width

			local xpbarBG = xpbar:CreateTexture(nil, "BORDER")
			xpbarBG:SetAllPoints(xpbar)
			xpbarBG:SetTexture(1, 1, 1, 1)
			xpbarBG:SetVertexColor(mcfg.c.bg.r and mcfg.c.bg.r or 0.06, mcfg.c.bg.g and mcfg.c.bg.g or 0.06, mcfg.c.bg.b and mcfg.c.bg.b or 0.06, 1)
			xpbar.bg = xpbarBG

			local indicator = xpbar:CreateTexture(nil, "OVERLAY")
			indicator:SetWidth(mcfg.size.iw and mcfg.size.iw or 1.5)
			indicator:SetTexture(1,1,1,1)
			indicator:SetVertexColor(mcfg.c.ind.r and mcfg.c.ind.r or classColor.r, mcfg.c.ind.g and mcfg.c.ind.g or classColor.g, mcfg.c.ind.b and mcfg.c.ind.b or classColor.b, 1)
			indicator:SetHeight(defaults.Height+4)
			xpbar.ind = indicator

			local restindicator = xpbar:CreateTexture(nil, "OVERLAY")
			restindicator:SetWidth(mcfg.size.iw and mcfg.size.iw or 1.5)
			restindicator:SetTexture(1, 1, 1, 1)
			restindicator:SetVertexColor(mcfg.c.rind.r and mcfg.c.rind.r or 0, mcfg.c.rind.g and mcfg.c.rind.g or 0.5, mcfg.c.rind.b and mcfg.c.rind.b or 1, 1)
			restindicator:SetHeight(defaults.Height+4)
			xpbar.rind = restindicator

			local qxpindicator = xpbar:CreateTexture(nil, "OVERLAY")
			qxpindicator:SetWidth(mcfg.size.iw and mcfg.size.iw or 1.5)
			qxpindicator:SetTexture(1, 1, 1, 1)
			qxpindicator:SetVertexColor(mcfg.c.qxpind.r and mcfg.c.qxpind.r or 0, mcfg.c.qxpind.g and mcfg.c.qxpind.g or 1, mcfg.c.qxpind.b and mcfg.c.qxpind.b or 0.1, 1)
			qxpindicator:SetHeight(defaults.Height+4)
			xpbar.qxpind = qxpindicator

			if(mcfg.show.tqxp ~= nil) then
				if(mcfg.show.tqxp) then
					textQxp:Show()
					xpbar.addtext = true
				else
					textQxp:Hide()
					xpbar.addtext = false
				end
			else
				mcfg.show.tqxp = true
				textQxp:Show()
				xpbar.addtext = true
			end

			xpbar:PLAYER_ENTERING_WORLD()
	end

end

function xpbar:Move(ind, perc)
	ind:ClearAllPoints()
	ind:SetPoint("TOPLEFT", xpbar, "TOPLEFT", string.format("%.0f", defaults.Width * perc), 2)

	-- display percentage on the side of the indicator, where it doesn't go out of bounds of the bar
	textMain:ClearAllPoints()
	if(perc>0.5) then
		textMain:SetPoint("RIGHT", ind, "LEFT", -10, 0)
	else
		textMain:SetPoint("LEFT", ind, "RIGHT", 10, 0)
	end
end

function xpbar:RestMove(ind, perc)
	ind:ClearAllPoints()
	if(perc) then
		if (perc>2) then
			perc=perc-2
		elseif (perc>1) then
			perc=perc-1
		end
		if perc>0 then
			ind:Show()
			ind:SetPoint("TOPLEFT", xpbar, "TOPLEFT", string.format("%.0f", xpbar:GetWidth() * perc), 2)
		else
			ind:Hide()
		end
	else
		ind:Hide()
	end
end

function xpbar:QxpMove(ind, qxp)
	ind:ClearAllPoints()
	if (qxp) then
		if (qxp>1) then
			qxp = qxp-(qxp-qxp%1)
			textQxp:SetText("Enough QXP to Level Up")
		end
		ind:Show()
		ind:SetPoint("TOPLEFT", xpbar, "TOPLEFT", string.format("%.0f", defaults.Width * qxp), 2)
	else
		ind:Hide()
	end
end

function xpbar:FMove(ind, perc)
	ind:ClearAllPoints()
	ind:SetPoint("TOPLEFT", xpbar, "TOPLEFT", string.format("%.0f", defaults.Width * perc), 2)

	textMain:ClearAllPoints()
	if(perc>0.5) then
		textMain:SetPoint("RIGHT", ind, "LEFT", -10, 0)
	else
		textMain:SetPoint("LEFT", ind, "RIGHT", 10, 0)
	end
end

xpbar:SetScript("OnMouseUp", function(self, bt)
	mouseclick(self, bt)
end)



-- Event responding
function xpbar:PLAYER_ENTERING_WORLD()

	if UnitLevel('player') == MAX_PLAYER_LEVEL then
        self:UPDATE_FACTION()
	else
		self:PLAYER_XP_UPDATE()
 	end
end

function xpbar:PLAYER_XP_UPDATE()

	local min = UnitXP("player")
	local max = UnitXPMax("player")
	local rested =  GetXPExhaustion()

	textMain:SetFormattedText("|cffffffff%.1f|r%%", min/max*100)
	textBL:SetFormattedText("%s", fc.comma(min))
	textBR:SetFormattedText("%s", fc.comma(max))
	textTL:SetFormattedText("|cffffffff%.1f|r bars", min/max*20)
	textTR:SetFormattedText("|cffffffff%.1f|r bars", min/max*20-20)
		-- NONONONONO
		textTL:SetFormattedText("")
		textTR:SetFormattedText("")

	m = "exp"
	local trest, tqxp
	local gqxp = fc.GetQxp()
	if(rested) then
		trest = " +".. fc.comma(rested) .. " rested"
	else
		trest = " +0 rested"
		rested = 0
	end
	if(gqxp) then
		tqxp = " +".. fc.comma(gqxp) .. " qxp"
	else
		tqxp = " +0 qxp"
		gqxp = 0
	end

	textQxp:SetText(trest .. " " .. tqxp)

	self:Move(xpbar.ind, min/max)
	if(rested==0) then
		self:RestMove(xpbar.rind, nil)
	else
		self:RestMove(xpbar.rind, (min+rested)/max)
	end
	if(gqxp==0) then
		self:QxpMove(xpbar.qxpind, nil)
	else
		self:QxpMove(xpbar.qxpind, (min+gqxp)/max)
	end
end

function xpbar:UPDATE_FACTION()

    if UnitLevel('player') == MAX_PLAYER_LEVEL then
		local name, standing, min, max, value = GetWatchedFactionInfo()
		if(not name) then
			print("Advancement < Error reporting reputation: No reputation selected to watch in the default interface")
			return nil
		end
		max, min = (max-min), (value-min)

	   	textMain:SetFormattedText("|cffffffff%.1f|r%%", min/max*100)
		textBL:SetFormattedText("|cffffffff%s|r (|cffffffff%s|r)", name, _G['FACTION_STANDING_LABEL'..standing])
		textBR:SetFormattedText("|cffffffff%s|r / |cffffffff%s|r", fc.comma(min), fc.comma(max))
		textTL:SetFormattedText("")
		textTR:SetFormattedText("")
		m = "rep"
	   	self:FMove(xpbar.ind, min/max)
	end

end

xpbar.PLAYER_LEVEL_UP = xpbar.PLAYER_ENTERING_WORLD
xpbar.PLAYER_UPDATE_RESTING = xpbar.PLAYER_ENTERING_WORLD
xpbar.UPDATE_EXHAUSTION = xpbar.PLAYER_ENTERING_WORLD
xpbar.QUEST_LOG_UPDATE = xpbar.PLAYER_ENTERING_WORLD

--	RegisterEvents

xpbar:SetScript("OnEvent", function(self, event, ...) self[event](self, event, ...)
end)

xpbar:RegisterEvent("PLAYER_XP_UPDATE")
xpbar:RegisterEvent('UPDATE_FACTION')
xpbar:RegisterEvent("PLAYER_LEVEL_UP")
xpbar:RegisterEvent("PLAYER_ENTERING_WORLD")
xpbar:RegisterEvent("ADDON_LOADED")
xpbar:RegisterEvent("PLAYER_UPDATE_RESTING")
xpbar:RegisterEvent("UPDATE_EXHAUSTION")
xpbar:RegisterEvent("QUEST_LOG_UPDATE")
