﻿--get the addon namespace
local addon, ns = ...

--generate a holder for the config data
--local cfg = CreateFrame("Frame")

local fc = CreateFrame("Frame")
local tbl = CreateFrame("Frame")

fc.echo = function(that)
	print(that)
end

-- taken from http://lua-users.org/wiki/FormattingNumbers
fc.comma = function(n)
	if(n) then
		local left,num,right = string.match(tostring(n), '^([^%d]*%d)(%d*)(.-)$')
		return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
	else
		return ""
	end
end

-- taken somewhere
fc.truncate = function(value)
	if(value > 999 or value < -999) then
		return string.format("%.1fk", value / 1e3)
	else
		return value
	end
end

-- taken from http://www.wowwiki.com/RGBPercToHex
fc.RGBPercToHex = function(r, g, b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

-- opens all headers and sums completed quests experience, doprint = true, to print out quest links and their exp and to show the sum in chat window
-- reporting can be nice when the user clicks the button in menu for a local report
fc.GetQxp = function(localzone, doprint, announce)
	local totalqxp = 0
	ExpandQuestHeader(0)
	for i=1, GetNumQuestLogEntries() do
	   local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(i)
	   if((not isHeader) and (isComplete == 1)) then
		   SelectQuestLogEntry(i)
		   if(doprint) then print("|cffF08010|Hquest:" .. questID .. ":".. level .."|h[".. questTitle .. "]|h|r", fc.comma(GetQuestLogRewardXP()), "exp") end
		   totalqxp = totalqxp + GetQuestLogRewardXP()
	   end
	end
	if(doprint) then print("Total completed quest experience:", fc.comma(totalqxp)) end
	return totalqxp
end



tbl.fclasses = {}
FillLocalizedClassList(tbl.fclasses, true)
tbl.mclasses = {}
FillLocalizedClassList(tbl.mclasses, false)

tbl.lmc = {} -- the actual male class colors
for token, localizedName in pairs(tbl.mclasses) do
   tbl.lmc[localizedName] = RAID_CLASS_COLORS[token];
end
tbl.lfc = {} -- the actual female class colors
for token, localizedName in pairs(tbl.fclasses) do
   tbl.lfc[localizedName] = RAID_CLASS_COLORS[token];
end
-- tha return
fc.GetLocalColors = function(cca)
--	local cca = cn
	if(tbl.lmc[cca]) then
		return	tbl.lmc[cca].r, tbl.lmc[cca].g, tbl.lmc[cca].b
	elseif(tbl.lfc[cca]) then
		return	tbl.lfc[cca].r, tbl.lfc[cca].g, tbl.lfc[cca].b
	else
		return nil, nil, nil
	end
end


ns.fc = fc
ns.tbl = tbl
